<?php
defined('CMBASIC') or die();

/* Dateiliste und Upload-Modul
 * blendet Dateien des gewnschten Ordners ein
 * berarbeitet am 06.11.2010 von Frank Finsterbusch (ffhex@arcor.de) 
 * @version beta 0.3
 * @date 2010-03-03
 * @author JCHanke mit Code von Mattias Fleischer
 * @copyright 2010 by JCHanke, www.cmbasic.de
 * @lizenz GNU GPL
 */

define('FILELISTBASE', 'download'); // Stammordner des FILELIST-Moduls, voreingestellt: download
$filelist_protect = array('index.html'); // Dateien die geschtzt werden sollen, voreingestellt: index.html

preg_match_all("/{((filelist),([a-zA-Z0-9-_]+))}/i", $acticon, $uploaderfund);


foreach ($uploaderfund[1] as $uploaderfund_komp) {

  if (isset($friendlyURL) && ($friendlyURL)) {
    $fileanhang = "$getAnhang.html";
    $sign = "?";
    $newQueryString = explode('?', $_SERVER['REQUEST_URI']);
    $newQueryString = $newQueryString[1];
    $newGetArr = explode('&', $newQueryString);
    foreach ($newGetArr as $value) {
      $newGetVar = explode('=', $value);
	  $_GET[$newGetVar[0]] = $newGetVar[1];
    }
  } else {
    $fileanhang = "?$getAnhang";
    $sign = "&amp;";
  }
  $folder = '';

  $basehandle = opendir(FILELISTBASE);
  while($rd = readdir($basehandle)) {
    if (substr_count($rd, '.') == 0) {    
      $allowed_folders[] = $rd;	
    }
  }  

  $uploaderpara = explode(",", $uploaderfund_komp);
  if (!empty($uploaderpara[1]) && in_array($uploaderpara[1], $allowed_folders)) {
    $folder = $uploaderpara[1];
  }
  else { 
    break;
  }

  $pfad =   FILELISTBASE . "/$folder/";
  $folderhandle = opendir($pfad);
  while($rd = readdir($folderhandle)) {
    if ($rd != "." && $rd != "..") {    
      $allowed_files[] = $rd;	
    }
  }  

  $output = '';
  if (isset($show_edit) && $show_edit == true) {
    $output .= <<<FILEFORM
<h2>Datei hier hochladen:</h2><strong>$pfad</strong>
<form action="" method="post" enctype="multipart/form-data">
<input type="hidden" name="folder" value="$folder" />
<input type="file" name="datei">
<input type="submit" name="submit" value="Datei hochladen">
</form>
FILEFORM;
}
  $dirhandle = opendir($pfad); // Dateien auslesen Anfang
  if (isset($_FILES['datei']) && $_FILES['datei']['size'] > 0) {
    $tempname = $_FILES['datei']['tmp_name'];
    $dateiname = $_FILES['datei']['name'];

  // Ersetzen der Leer- und Sonderzeichen  
  $dateiname = str_replace("  ", " ", $dateiname);
  $dateiname = str_replace("  ", " ", $dateiname);
  $dateiname = str_replace(" ", "_", $dateiname);
  $dateiname = str_replace("", "A", $dateiname);
  $dateiname = str_replace("", "a", $dateiname);
  $dateiname = str_replace("", "A", $dateiname);
  $dateiname = str_replace("", "a", $dateiname);
  $dateiname = str_replace("", "A", $dateiname);
  $dateiname = str_replace("", "a", $dateiname);
  $dateiname = str_replace("", "A", $dateiname);
  $dateiname = str_replace("", "a", $dateiname);
  $dateiname = str_replace("", "A", $dateiname);
  $dateiname = str_replace("", "a", $dateiname);
  $dateiname = str_replace("", "A", $dateiname);
  $dateiname = str_replace("", "a", $dateiname);
  $dateiname = str_replace("", "Ae", $dateiname);
  $dateiname = str_replace("", "ae", $dateiname);
  $dateiname = str_replace("", "C", $dateiname);
  $dateiname = str_replace("", "c", $dateiname);
  $dateiname = str_replace("", "E", $dateiname);
  $dateiname = str_replace("", "e", $dateiname);
  $dateiname = str_replace("", "E", $dateiname);
  $dateiname = str_replace("", "e", $dateiname);
  $dateiname = str_replace("", "E", $dateiname);
  $dateiname = str_replace("", "e", $dateiname);
  $dateiname = str_replace("", "E", $dateiname);
  $dateiname = str_replace("", "e", $dateiname);
  $dateiname = str_replace("", "I", $dateiname);
  $dateiname = str_replace("", "i", $dateiname);
  $dateiname = str_replace("", "I", $dateiname);
  $dateiname = str_replace("", "i", $dateiname);
  $dateiname = str_replace("", "I", $dateiname);
  $dateiname = str_replace("", "i", $dateiname);
  $dateiname = str_replace("", "I", $dateiname);
  $dateiname = str_replace("", "i", $dateiname);
  $dateiname = str_replace("", "N", $dateiname);
  $dateiname = str_replace("", "n", $dateiname);
  $dateiname = str_replace("", "O", $dateiname);
  $dateiname = str_replace("", "o", $dateiname);
  $dateiname = str_replace("", "O", $dateiname);
  $dateiname = str_replace("", "o", $dateiname);
  $dateiname = str_replace("", "O", $dateiname);
  $dateiname = str_replace("", "o", $dateiname);
  $dateiname = str_replace("", "O", $dateiname);
  $dateiname = str_replace("", "o", $dateiname);
  $dateiname = str_replace("", "Oe", $dateiname);
  $dateiname = str_replace("", "oe", $dateiname);
  $dateiname = str_replace("", "Oe", $dateiname);
  $dateiname = str_replace("", "oe", $dateiname);
  $dateiname = str_replace("", "U", $dateiname);
  $dateiname = str_replace("", "u", $dateiname);
  $dateiname = str_replace("", "U", $dateiname);
  $dateiname = str_replace("", "u", $dateiname);
  $dateiname = str_replace("", "U", $dateiname);
  $dateiname = str_replace("", "u", $dateiname);
  $dateiname = str_replace("", "Ue", $dateiname);
  $dateiname = str_replace("", "ue", $dateiname);
  $dateiname = str_replace("Y", "Y", $dateiname);
  $dateiname = str_replace("y", "y", $dateiname);
  $dateiname = str_replace("", "ss", $dateiname);
	
    $dateigroesse = byte_calc($_FILES['datei']['size']);
    while ($file = readdir($dirhandle)) {
      if ($file == $dateiname) { // Vergleichen, ob Datei schon vorhanden
        $dateiname = "_" . $dateiname; // Unterstrich am Anfang einbauen
      }
    }
     $myDestination = FILELISTBASE .'/'. $_POST['folder'].'/';  // Ziel entsprechend hidden'folder'
       // print " myDest: ".$myDestination." Pfad: ".$pfad;;   // Testausgabe
    if ($pfad == $myDestination) { // Meldungen an der richtigen filelist - Position ausgeben
      if (move_uploaded_file($tempname, $myDestination . $dateiname)) {
        chmod($myDestination . $dateiname, 0666);
        $output .= "<h2>Hochladen erfolgreich!</h2>
        <p>Die Datei wurde <b>erfolgreich</b> hochgeladen!<br>
        Dateigre: <b>$dateigroesse</b><br/>
        Dateiname: <b>$dateiname</b><br/>
        Dateiordner: <b>$_POST[folder]</b><br/>
        Serverpfad: <b>$myDestination</b></p>
        <form action=\"\" method=\"post\">
        <input type=\"submit\" value=\"OK\"></form>";
      } else {
        $output .= "<h2>Upload nach $myDestination war leider nicht erfolgreich!</h2>";
      }
    }
  }
  // Hier wird die Datei gelscht
  if (isset($_GET['delete']) &&  in_array($_GET['delete'], $allowed_files) && 
  isset($_GET['folder']) && in_array($_GET['folder'], $allowed_folders)) { // Prfen, ob URL-Parameter bergeben wird und gltig sind
    // Lschfunktion aufrufen
    if (@unlink("$pfad$_GET[delete]")) {
      // Statusmeldung ausgeben
     $output .= "<h2>Datei $_GET[delete] im Ordner $pfad wurde gelscht! -
<a href=\"$fileanhang$sign" . "folder=$folder\">Alles klar!</a></h2>";
    } else {
      $output .= "<h2>Lschen nicht erfolgreich! - <a href=\"$fileanhang$sign" . "folder=$folder\">Abbruch!</a></h2>";
    }
  } elseif (isset($_GET['newtime']) &&  in_array($_GET['newtime'], $allowed_files) && 
  isset($_GET['folder']) && in_array($_GET['folder'], $allowed_folders)) {
    // Hier wird das Datum aktualisiert
    if (!touch("$pfad$_GET[newtime]")) {
      // Statusmeldung nur bei Misserfolg
      $output .= "<h2>Datumsaktualisierung nicht erfolgreich! - <a href=\"$fileanhang$sign" . "folder=$folder\">Abbruch!</a></h2>";
    }    
  }
$dateiausgabe_arr = array();    // Array leeren
  while ($file = readdir($dirhandle)) {
    if ($file != "." && $file != ".." && !in_array($file, $filelist_protect)) {
      clearstatcache();
      	  $groesse = byte_calc(filesize($pfad . $file));
	  $filetimestamp = filemtime($pfad . $file);
	  $dateidatum = date ("d.m.Y", $filetimestamp);
      $dateiausgabe_arr[$filetimestamp] = "<!-- <img src=\"backend/css/file.gif\" width=\"17\" height=\"18\" border=\"0\" alt=\"\"> -->
<a href=\"$pfad$file\" class=\"normal\" target=\"_blank\" title=\"Linksklick: Datei $file direkt ffnen, Rechtsklick: Download\">$file</a> <small>($groesse, Stand: $dateidatum)</small>";
      if (isset($show_edit) && $show_edit == true) {
        $dateiausgabe_arr[$filetimestamp] .= " -&gt; <a href=\"$fileanhang$sign" . 
        "delete=$file&amp;folder=$folder\"
        onClick=\"return confirm('Mchten Sie die Datei: $file wirklich lschen?');\">Lschen?</a> " .
        "<a href=\"$fileanhang$sign" . "newtime=$file&amp;folder=$folder\"
        onClick=\"return confirm('Mchten Sie die Datei: $file wirklich ganz nach oben schieben?');\">Hoch?</a>";
      } 
        $dateiausgabe_arr[$filetimestamp] .= "";
      }
    }
    
    if (isset($dateiausgabe_arr)) {
    // nach Alphabet sortieren
       // asort($dateiausgabe_arr, SORT_STRING);   // aufsteigend alphabetisch (nach Dateiname) sortieren
      krsort($dateiausgabe_arr, SORT_NUMERIC);   // absteigend (nach Timestamp) sortieren
     // Dateien ausgeben
      foreach ($dateiausgabe_arr as $value) {
       $output .= "<li>$value</li>";
      }
    }
    $output = "<ul>$output</ul>";
    closedir($dirhandle); // Dateien auslesen Ende

    $muster = "|{filelist,$uploaderpara[1]}|";
    $acticon = preg_replace($muster, $output, $acticon);
}  
?>