<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
<title>Mini-CMS</title>
<meta http-equiv="content-type" content="text/html; charset=iso-8859-1">
<link rel="stylesheet" type="text/css" href="../backend/css/backend.css">
<link rel="stylesheet" type="text/css" href="../css/spezial/spezial.css">  
</head>
<body>
<div>
<h1>Datenbanksetup ohne Beispieldateien</h1>
<?php
include "../edit/config.inc.php";
include "../zugriff.inc.php";
$schritt1 = false;
$sqlcode = "
CREATE TABLE `{$pfx}content` (
  `URLAnhang` varchar(30) NOT NULL default '',
  `MenueName` varchar(35) default NULL,
  `Ebene1` smallint(6) default NULL,
  `Ebene2` smallint(6) default NULL,
  `Seitentitel` varchar(85) default NULL,
  `Content` text,
  `KastenNr` smallint(6) default NULL,
  PRIMARY KEY  (`URLAnhang`)
) ;

INSERT INTO {$pfx}content VALUES ('home', 'Startseite', '1', '0', 'Willkommen auf der Startseite', '<h1>Willkommen bei CMBasic!</h1>', '0') ;

CREATE TABLE `{$pfx}newsbox` (
  `KastenNr` smallint(6) NOT NULL default '0',
  `KastenHead` varchar(50) default NULL,
  `KastenText` text ,
  PRIMARY KEY  (`KastenNr`)
) ;

CREATE TABLE `{$pfx}rights` (
  `URLAnhang` varchar(25) NOT NULL default '',
  `user` varchar(15) NOT NULL default '',
  PRIMARY KEY  (`URLAnhang`,`user`)
) ;

CREATE TABLE `{$pfx}user` (
  `user` varchar(15) NOT NULL default '',
  `pw` varchar(50) default NULL,
  `rights` tinyint(4) default NULL,
  PRIMARY KEY  (`user`)
) ;

INSERT INTO {$pfx}user VALUES ('admin', '0752fa8b82411b5353dc1c9b88998655', '4')
";

$aret = explode(";", $sqlcode);
$sqlcontrol = "";
$sqlview = "";
foreach ($aret as $name => $value) {
  $value = stripslashes($value);
  $sqlcontrol .= "<small><b>Befehl $name</b>: " . htmlspecialchars($value) . "</small><br>";
    if (@mysql_query($value)) {
      $sqlview .= "$value;\r\n";
    } 
  } 
if (!empty($sqlview)) {
  $schritt1 = true;
  echo "<p class='success'>Datenbanktabellen <b>erfolgreich</b> eingerichtet.</p>";
} else {
  echo "<p class='nosuccess'>Datenbanktabellen konnten leider <b>nicht</b> eingerichtet werden.
    Vielleicht existieren sie ja schon? </p>
    <p><a href='welcome.php'>Zurck zur Setup-Startseite</a> - 
    <a href='../'>Zum Mini-CMS</a> -
    <a href='../backend/'>Zum Backend</a>
    </p>";
} 

if ($schritt1) {
  echo "<p>Die Einrichtung der Datenbanktabelle war erfolgreich, daher muss das Setup
    <b>nicht</b> mehr aufgerufen werden. Lschen Sie <b>unbedingt sofort</b> den <strong>setup</strong>-Ordner!</p>
    <p><a href='welcome.php'>Zurck zur Setup-Startseite</a> - 
    <a href='../'>Zum Mini-CMS</a> -
    <a href='../backend/'>Zum Backend</a>
    </p>
    <h3>In Abhngigkeit vom Dienstleister mssen Sie ggf. einen chmod setzen fr die images-Ordner, den files-Ordner und den stats-Ordner:</h3>
    <p>Insgesamt bei folgenden Ordnern:</p>
    <ul>
    <li>images1</li>
    <li>images2</li>
    <li>images3</li>
    <li>files</li>
    <li>scripts/stats</li>
    </ul>
    <p>Auch die fr das Feedbackformular wichtige Datei <strong>backend/unique.txt</strong> muss beschreibbar sein.</strong>
    <p class=\"tipp\">Diese Freigabe ist jedoch bei vielen Dienstleistern gar nicht ntig, z.B. bei 1&1, Strato oder PS-Webhosting! Selbst All-inkl.com kann man so konfigurieren, dass diese Beschrnkung entfllt. Erstellen Sie eine Datei namens <b>.htaccess</b> bzw. ergnzen Sie die schon bestehende <b>.htaccess</b> um folgende Zeile:<br><code>AddHandler php-cgi .php .php5</code>.<br>Schon luft PHP im CGI-Modus und die Ordnerfreigabe ist nicht mehr ntig!</p>
    ";
} 

?>
</div>
</body>
</html>